// __multiversion__
#include "fragmentVersionCentroid.h"

#if __VERSION__ >=300
#ifndef BYPASS_PIXEL_SHADER
#if defined(TEXEL_AA) && defined(TEXEL_AA_FEATURE)
_centroid in highp vec2 uv0;
_centroid in highp vec2 uv1;
#else
_centroid in vec2 uv0;
_centroid in vec2 uv1;
#endif
#endif
#else
#ifndef BYPASS_PIXEL_SHADER
varying vec2 uv0;
varying vec2 uv1;
#endif
#endif

varying vec4 color;
varying POS3 V,D;
#ifdef LOW_PRECISION
varying vec4 fC;
#endif

#include "uniformShaderConstants.h"
#include "uniformPerFrameConstants.h"
#include "util.h"
#include "color.set"
#include "control.set"
uniform sampler2D TEXTURE_0;
uniform sampler2D TEXTURE_1;
uniform sampler2D TEXTURE_2;
highp float rand(highp vec2 A){return fract(sin(A.x+A.y*7.)*9.);}
highp float noise(highp vec2 A){
highp vec2 B=floor(A);
highp vec2 C=fract(A);
highp vec2 D=C*(2.-C);
return 2.*mix(mix(rand(B+vec2(.0,.0)),rand(B+vec2(1.,.0)),D.x),mix(rand(B+vec2(.0,1.)),rand(B+vec2(1.)),D.x),D.y)-1.;}
highp float WP(highp vec3 v1,highp vec3 v2){return (v1.x*v2.x+v1.y*v2.y+v1.z*v2.z)/length(v1)/length(v2);}
highp float WV(highp vec3 A){
A.z+=TIME*.3;
return sin(noise(vec2(A.x*.2+A.z*.2+A.y*.3+A.x*.2,A.z*.3+A.x*.2+A.z*.4)));}
highp vec3 WM(highp vec3 B){
highp float H=WV(B+vec3(.3,.2,.1));
return vec3(-H,Cc,1.);}
vec3 TM(vec3 x){
float A=.9;
float B=.1;
float C=.1;
float D=.5;
float E=.07;
float F=.3;
return ((x*(A*x+C*B)+D*E)/(x*(A*x+B)+D*F))-E/F;}
void main(){
float sX=1.;
float sY=uv1.y;
vec4 nc=texture2D(TEXTURE_1,vec2(0.,1.));
float Ti=(nc.r-.5)/.5;
Ti=max(0.,min(1.,Ti));
float nt=sY*(1.-Ti);
#ifdef BYPASS_PIXEL_SHADER
gl_FragColor=vec4(0);
return;
#else
#if USE_TEXEL_AA
vec4 XR=texture2D_AA(TEXTURE_0,uv0);
#else
vec4 XR=texture2D(TEXTURE_0,uv0);
#endif
#ifdef SEASONS_FAR
XR.a=1.;
#endif
vec4 f=FOG_COLOR;
vec3 sh=shc+uv1.x*vec3(.09);
vec4 G=color;
float bvb=abs(acos(WP(V,WM(V))));
vec3 FC=fC.rgb;
float b=pow(max(min(f.r*1.5,1.),0.),1.3);
float c=(1.-pow(FOG_CONTROL.y,5.))*sY;
float a=pow(max(min(1.-f.b,1.),0.),.5)-nt-c;
vec4 L=ls;
#if USE_ALPHA_TEST
#ifdef ALPHA_TO_COVERAGE
#define A .05
#else
#define A .5
#endif
if(XR.a<A)
discard;
#endif
#ifndef ALWAYS_LIT
XR*=texture2D(TEXTURE_1,uv1);
#endif
#ifndef SEASONS
XR.rgb*=G.rgb;
#else
vec2 uv=G.xy;
XR.rgb*=mix(vec3(1.),texture2D(TEXTURE_2,uv).rgb*2.,G.b);
XR.rgb*=G.aaa;
XR.a=1.;
#endif
if((f.r>f.g)&&(f.b>f.g)&&(f.b>f.r)&&(f.r<.05&&f.b<.05&&f.g<.05)){
c=0.;
XR.rgb/=md;
FC=fmd;
L=lmd;}
if((f.b==f.g)&&(f.b*1.5<f.r)){
c=0.;
XR.rgb/=dy;
FC=fdy;}
XR.rgb*=mix(wd,wn,nt);
XR.rgb-=wr*c*.4*((1.-nt)*sY);
#ifdef BLEND
if(G.r<G.g*1.1&&G.r<G.b){G.a=tw;
XR=mix(mix(mix(mix(G*wsd,G*.6*wsn,1.-b),wsr*(b*.7+.3),c),G*.7,1.-sY),fC,fC.a)+(bvb*.1*(b+.5)*sY);
L.a=abs(bvb*6.)*sY;}
if(G.r>G.g*1.1&&G.r>G.b){L.a=0.;}
#endif
if((f.b>.15&&(f.b>f.g*1.2)&&(f.b>=f.r*1.8)&&(f.g>f.r*1.6))||(f.g*1.2>=f.b)&&(f.r*1.3<f.g)){
XR.rgb*=mix(wuw,wew,b);
FC=fuw;
XR.rgb+=bvb*Cj*sY+UA*max(sY,0.)*(1.-nt);
L=luw;}
#ifndef BLEND
if(G.g<G.b*1.05){sX=G.g*1.5+nt;}
#ifdef ALPHA_TEST
sX=G.g*2.+nt;
sY=1.;
#endif
#endif
for(float i=0.;i<6.;i++){if((sY<.875+i*.001)||(sX<.71-i*.004)){XR.rgb*=sh;}}
XR+=XR*(L*Ck-.4)*max(max(nt,1.-sY),c)*pow(uv1.x,3.);
XR.rgb=TM(XR.rgb)/TM(vec3(1.));
#ifdef LOW_PRECISION
XR.rgb=mix(XR.rgb,FC,fC.a);
#endif
gl_FragColor=XR;
#endif
}