// __multiversion__
#include "vertexVersionCentroid.h"
#if __VERSION__ >= 300
#ifndef BYPASS_PIXEL_SHADER
_centroid out vec2 uv0;
_centroid out vec2 uv1;
#endif
#else
#ifndef BYPASS_PIXEL_SHADER
varying vec2 uv0;
varying vec2 uv1;
#endif
#endif

#ifndef BYPASS_PIXEL_SHADER
varying vec4 color;
#endif
#ifdef LOW_PRECISION
varying vec4 fC;
#endif
varying POS3 V,D;

#include "uniformWorldConstants.h"
#include "uniformPerFrameConstants.h"
#include "uniformShaderConstants.h"
#include "uniformRenderChunkConstants.h"
#include "color.set"
#include "control.set"
attribute POS4 POSITION;
attribute vec4 COLOR;
attribute vec2 TEXCOORD_0;
attribute vec2 TEXCOORD_1;
void main(){
POS4 wP;
#ifdef AS_ENTITY_RENDERER
POS4 A=WORLDVIEWPROJ*POSITION;
wP=A;
#else
wP.xyz=POSITION.xyz+CHUNK_ORIGIN_AND_SCALE.xyz;
wP.w=1.;
POS4 A=WORLDVIEW*wP;
A=PROJ*A;
#endif
gl_Position=A;
V=wP.xyz;
D=POSITION.xyz;
vec4 f=FOG_COLOR;
#ifndef BYPASS_PIXEL_SHADER
uv0=TEXCOORD_0;
uv1=TEXCOORD_1;
color=COLOR;
#endif
#ifdef LOW_PRECISION
float len=length(wP.xyz)/FAR_CHUNKS_DISTANCE;
#ifdef ALLOW_FADE
len+=RENDER_CHUNK_FOG_ALPHA;
#endif
#endif
fC.rgb=f.rgb*wf;
fC.a=clamp(len-(FOG_CONTROL.x*.1)/(FOG_CONTROL.y-FOG_CONTROL.x),.0,fg);
if(((color.r<color.g*.6)||(color.r<color.b&&color.r<color.g*.8))&&color.a>0.){fC.a=clamp(len-(FOG_CONTROL.x*.1)/(FOG_CONTROL.y-FOG_CONTROL.x*.2),.0,1.);}
float sm=0.;
float zw=0.;
float c=1.-pow(FOG_CONTROL.y,5.);
float W=Cl*sin(TIME*la+V.z+V.z+V.x+cos(TIME*lb+V.z))*sin(TIME*lc+V.x)*(1.-fC.a);
float P=Cm*sin(TIME*wa+D.z+D.z+D.x+cos(TIME*wb+D.z))*sin(TIME*wc+D.x)*uv1.y*(1.+c*Ar);
float w=W*uv1.y;
#ifdef ALPHA_TEST
if(color.g*2.>color.r+color.b){zw=1.;}
#endif
#ifdef BLEND
if(color.r<color.g*1.1&&color.r<color.b){sm=1.;}
#endif
if(sm>.5){gl_Position.y+=w*.4;}
if(zw>.5){gl_Position.xy+=P*.2;}
if((f.b>.15&&(f.b>f.g*1.2)&&(f.b>=f.r*1.8)&&(f.g>f.r*1.6))||(f.g*1.2>=f.b)&&(f.r*1.3<f.g)&&zw<1.){gl_Position.xy+=W*.1;}
}